//###########################################################################
//
// FILE:    qep.c
//
// TITLE:   G32R501 QEP driver.
//
// VERSION: 1.0.0
//
// DATE:    2025-01-15
//
//###########################################################################
// $Copyright:
// Copyright (C) 2024 Geehy Semiconductor - http://www.geehy.com/
// Copyright (C) 2023 Texas Instruments Incorporated - http://www.ti.com/
//
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions 
// are met:
// 
//   Redistributions of source code must retain the above copyright 
//   notice, this list of conditions and the following disclaimer.
// 
//   Redistributions in binary form must reproduce the above copyright
//   notice, this list of conditions and the following disclaimer in the 
//   documentation and/or other materials provided with the   
//   distribution.
// 
//   Neither the name of Texas Instruments Incorporated nor the names of
//   its contributors may be used to endorse or promote products derived
//   from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// $
//
// Modifications:
// - 2024-09-13:
// 1. Module naming
//
//###########################################################################

#include "qep.h"

//*****************************************************************************
//
// QEP_setCompareConfig
//
//*****************************************************************************
void
QEP_setCompareConfig(uint32_t base, uint16_t config, uint32_t compareValue,
                      uint16_t cycles)
{
    uint16_t regValue;

    //
    // Check the arguments.
    //
    ASSERT(QEP_isBaseValid(base));
    ASSERT(cycles <= (QEP_QPOSCTL_PCSPW_M + 1U));

    //
    // Set the compare match value
    //
    HWREG(base + QEP_O_QPOSCMP) = compareValue;

    //
    // Set the shadow register settings and pulse width.
    //
    regValue = (config & (uint16_t)(QEP_QPOSCTL_PCSHDW |
                  QEP_QPOSCTL_PCLOAD)) | (cycles - 1U);

    HWREGH(base + QEP_O_QPOSCTL) = (HWREGH(base + QEP_O_QPOSCTL) &
                                     ~(QEP_QPOSCTL_PCSPW_M |
                                       QEP_QPOSCTL_PCLOAD |
                                       QEP_QPOSCTL_PCSHDW)) | regValue;

    //
    // Set position compare sync-output mode.
    //
    regValue = config & (uint16_t)(QEP_QDECCTL_SOEN | QEP_QDECCTL_SPSEL);

    HWREGH(base + QEP_O_QDECCTL) = (HWREGH(base + QEP_O_QDECCTL) &
                                     ~(QEP_QDECCTL_SOEN |
                                       QEP_QDECCTL_SPSEL)) | regValue;
}

//*****************************************************************************
//
// QEP_setInputPolarity
//
//*****************************************************************************
void
QEP_setInputPolarity(uint32_t base, bool invertQEPA, bool invertQEPB,
                      bool invertIndex, bool invertStrobe)
{
    //
    // Check the arguments.
    //
    ASSERT(QEP_isBaseValid(base));

    //
    // Configure QEPA signal
    //
    if(invertQEPA)
    {
        HWREGH(base + QEP_O_QDECCTL) |= QEP_QDECCTL_QAP;
    }
    else
    {
        HWREGH(base + QEP_O_QDECCTL) &= ~QEP_QDECCTL_QAP;
    }

    //
    // Configure QEPB signal
    //
    if(invertQEPB)
    {
        HWREGH(base + QEP_O_QDECCTL) |= QEP_QDECCTL_QBP;
    }
    else
    {
        HWREGH(base + QEP_O_QDECCTL) &= ~QEP_QDECCTL_QBP;
    }

    //
    // Configure index signal
    //
    if(invertIndex)
    {
        HWREGH(base + QEP_O_QDECCTL) |= QEP_QDECCTL_QIP;
    }
    else
    {
        HWREGH(base + QEP_O_QDECCTL) &= ~QEP_QDECCTL_QIP;
    }

    //
    // Configure strobe signal
    //
    if(invertStrobe)
    {
        HWREGH(base + QEP_O_QDECCTL) |= QEP_QDECCTL_QSP;
    }
    else
    {
        HWREGH(base + QEP_O_QDECCTL) &= ~QEP_QDECCTL_QSP;
    }
}
